package com.fossgalaxy.games.tbs.editor.EditorView;

import com.fossgalaxy.games.tbs.GameState;
import com.fossgalaxy.games.tbs.editor.PlacementType;
import com.fossgalaxy.games.tbs.editor.tools.SinglePlace;
import com.fossgalaxy.games.tbs.editor.tools.Tool;
import com.fossgalaxy.games.tbs.entity.Entity;
import com.fossgalaxy.games.tbs.io.map2.EntityDef;
import com.fossgalaxy.games.tbs.io.map2.MapDef;
import com.fossgalaxy.games.tbs.parameters.EntityType;
import com.fossgalaxy.games.tbs.parameters.ResourceType;
import com.fossgalaxy.games.tbs.parameters.TerrainType;
import com.fossgalaxy.games.tbs.ui.UIModel;
import com.fossgalaxy.games.tbs.ui.UIModelListener;
import org.codetome.hexameter.core.api.CubeCoordinate;

public class MapToolListener implements EditorListener {

    private EditorModel model;

    public MapToolListener(EditorModel model){
        this.model = model;
    }

    @Override
    public void onMapDefLoaded(MapDef def) {

    }

    @Override
    public void onEntitySelected(EntityDef def) {

    }

    @Override
    public void onLocationSelected(CubeCoordinate pos) {

        Tool tool = model.getTool();
        if (tool == null) {
            return;
        }

        MapDef def = model.getDef();
        PlacementType type = model.getType();

        if (def != null) {

            switch (type) {
                case TERRAIN:
                    tool.placeTerrain(def, pos, model.getSelectedTerrain());
                    break;
                case RESOURCE:
                    tool.placeResource(def, pos, model.getSelectedResource());
                    break;
                case ENTITY:
                    tool.placeEntity(def, pos, model.getSelectedEntity(), model.getOwner());
            }

        }
    }

}
