package com.fossgalaxy.games.tbs.editor.tools;

import com.fossgalaxy.games.tbs.GameState;
import com.fossgalaxy.games.tbs.entity.Entity;
import com.fossgalaxy.games.tbs.entity.Resource;
import com.fossgalaxy.games.tbs.io.map2.MapDef;
import com.fossgalaxy.games.tbs.parameters.EntityType;
import com.fossgalaxy.games.tbs.parameters.ResourceType;
import com.fossgalaxy.games.tbs.parameters.TerrainType;
import org.codetome.hexameter.core.api.CubeCoordinate;

public class SinglePlace implements Tool {

    @Override
    public void placeTerrain(MapDef def, CubeCoordinate pos, TerrainType type) {
        def.setTerrian(pos, type);
    }

    @Override
    public void placeResource(MapDef def, CubeCoordinate pos, ResourceType type) {
        def.addResource(new Resource(type, pos, 1));
    }

    @Override
    public void placeEntity(MapDef state, CubeCoordinate pos, EntityType selectedEntity, int owner) {
        state.addEntity(new Entity(selectedEntity, pos, owner));
    }

    public String toString(){
        return "single";
    }
}
